function add(what, targ)
{
	var verb;
	var obj;
	var target;
	var thing;

	if (what == 'person') {
		verb = targ.personverb;
		obj = targ.personlist;
		target = targ.person_acl;
		thing = 'User';
	} else {
		verb = targ.groupverb;
		obj = targ.grouplist;
		target = targ.group_acl;
		thing = 'Group';
	}
	
	var perm = '';
	if (what == 'person') {
		perm = 'write';
	} else {
		for(var i = 0; i < verb.length; i++) {
			if (verb[i].checked == true) {
				perm = verb[i].value; 
			}
		}
	}

	if (perm == '') {
		alert('No permission selected');
		return;
	}

	if (obj.selectedIndex == -1) {
		alert('No ' + thing + ' Selected');
		return;
	}

	for (var ind = 0; ind < obj.options.length; ind++) {
		if (!obj.options[ind].selected) { continue; }
		var obj_id = obj.options[ind].value;
		var obj_name = obj.options[ind].text;

		var txt = perm + ':' + obj_name;
		// put obj_id first so it can be sorted easily by id
		var val = obj_id + ':' + perm;

		if ((what == 'group') && (val == 'self:read')) {
			alert("the combination 'read:self' is implicit.\n"
				+ "You do not need to specify it.");
			continue;
		}

		var abort_this = false;
		// check that the combination hasn't already been added
		for (var i = 0; i < target.options.length; i++) {
			if (val == target.options[i].value) {
				// continue;
				abort_this = true;
			}
		}

	 	if (abort_this) { continue; }

		// check if same group has been added with different perm
		for (var i = 0; i < target.options.length; i++) {
			var a = target.options[i].text.split(":");
			if (obj_name == a[1]) {
				alert("Replacing [" + target.options[i].text
					+ "] with [" + txt + "]");
				var o = new Option(txt, val);
				target.options[i] = o;
				abort_this = true;
			}
		}

	 	if (abort_this) { continue; }

		// add
		var o = new Option(txt, val);
		target.options[target.options.length] = o;
	}
}

function del(what, targ)
{
	var target;
	if (what == 'person') {
		target = targ.person_acl;
	} else {
		target = targ.group_acl;
	}

	if (target.selectedIndex == -1) {
		return;
	}
	// target.options[target.selectedIndex] = null;

	for (var i = target.options.length - 1; i >= 0; i--) {
		if (target.options[i].selected) {
			target.options[i] = null;
		}
	}
}

function id2Group(id, opt)
{
	for (var i = 0; i < opt.length; i++) {
		if (opt[i].value.split(":")[0] == id) {
			return opt[i].text.split(":")[1];
		}
	}
}

function validate(f)
{
	// assert that for each group ACL only one of r/w/a has been selected
	// var g = document.add_mod_person.group_acl;
	var g = f.group_acl;
	var a = new Array();
	for (var i = 0; i < g.options.length; i++) {
		a[i] = g.options[i].value;
	}
	a.sort();

	var prev = '';
	var elems;
	for(var i = 0; i < a.length; i++) {
		elems = a[i].split(":");
		if (elems[0] == prev) {
			alert("Group [" + id2Group(prev, g.options)
				+ "] has been selected multiple times.\n"
				+ "Per group only one of Admin, Write, or Read is allowed");
			return false;
		}
		prev = elems[0];
	}

	// lastly, select all elements in target selection elements
	var a = new Array(f.person_acl, f.group_acl);
	for(var i = 0; i < 2; i++) {
		for(var j = 0; j < a[i].options.length; j++) {
			a[i].options[j].selected = true;
		}
	}
	return true;
}
